'Notes: creates an xml NS6.x inventory of active x controlers and sends the inventory back to the parent NS
'by: Jon Mason & Kevin Wilhelm
'date: 3/18/2011
Option Explicit
'~ On Error resume next

Dim strComputer
Dim strKeyPath
Dim strValueName
Dim strValue
Dim arrValues
Dim intValue
Dim strDrivePath
strComputer = "."
	Dim invDate
	Dim timePagefile
	Dim timeBootstat
	Dim timeNetwrk
	Dim timeASS
	Dim timeACS
	Dim timeCtrlAltDel
	Dim timeLogin
	Dim timeLLogin
	Dim timeStartLogonScript
	Dim timeEndLogonScript
	Dim timeDesktopReady
	Dim strADSite
	Dim strUsersEUID

Const HKEY_LOCAL_MACHINE = &H80000002

Dim ofso, oNetwork, objRegistry
set ofso = CreateObject("Scripting.FileSystemObject")
Set oNetwork = CreateObject("Wscript.Network")
Set objRegistry = GetObject("winmgmts:\\.\root\default:StdRegProv")

Dim strAltirisDir
strKeyPath = "SOFTWARE\Altiris\Altiris Agent"
strValueName = "InstallDir"
objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName, strAltirisDir

if not oFso.FolderExists(strAltirisDir) then
	'~ wscript.echo "dir:" & strAltirisDir
	'~ wscript.echo "quit"
	wscript.quit
end if

strDrivePath = "C:\"
		Dim oPagefile
		Dim oBootstat
		Dim oNetwrk
		Dim oASS
		Dim oACS
		Dim oCtrlAltDel
		Dim oLogin
		Dim oLLogin
		Dim sBootstat
		Dim sPagefile
		Dim sNetwrk
		Dim sASS
		Dim sACS
		Dim sCtrlAltDel
		Dim sLogin
		Dim sLLogin
		Dim sDesktopReady

		Dim objADSysInfo
		Set objADSysInfo = CreateObject("ADSystemInfo")
		strADSite = objAdSysInfo.SiteName
		'~ wscript.echo "site: " & objAdSysInfo.SiteName

		'strUsersEUID = GetCurrentUser(strDrivePath)
		strKeyPath = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon"
		strValueName = "DefaultUserName"
		objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName, strUsersEUID

		sPagefile = strDrivePath & "pagefile.sys"
		sBootstat = strDrivePath & "Windows\bootstat.dat"
		sNetwrk = strDrivePath & "Documents and Settings\LocalService\Local Settings\desktop.ini"
		sASS = strDrivePath & "Documents and Settings\NetworkService\Local Settings\Application Data\Microsoft\Windows\UsrClass.dat.LOG"
		sACS = strDrivePath & "WINDOWS\security\templates\policies\gpt00001.dom"
	'	sCtrlAltDel = strDrivePath & "Windows\0.log"
		sCtrlAltDel = strDrivePath & "Windows\CSC\00000001"
		sLogin = strDrivePath & "Documents and Settings\" & strUsersEUID & "\ntuser.ini"
		sLLogin = strDrivePath & "Windows\System32\config\netlogon.ftl"
		sDesktopReady = strDrivePath & "Windows\Prefetch"

		Set oPagefile = oFSO.GetFile(sPagefile)
		sPagefile = oPagefile.DateLastModified
		timePagefile = sPagefile

		Set oBootstat = oFSO.GetFile(sBootstat)
		timeBootstat = oBootstat.DateLastModified

		Set oNetwrk = oFSO.GetFile(sNetwrk)
		timeNetwrk = oNetwrk.DateLastModified

		Set oASS = oFSO.GetFile(sASS)
		timeASS = oASS.DateLastModified

		Set oACS = oFSO.GetFile(sACS)
		timeACS = oACS.DateLastModified

		Set oCtrlAltDel = oFSO.GetFile(sCtrlAltDel)
		timeCtrlAltDel = oCtrlAltDel.DateLastModified

		Set oLogin = oFSO.GetFile(sLogin)
		timeLogin = oLogin.DateLastModified

		Set oLLogin = oFSO.GetFile(sLLogin)
		timeLLogin = oLLogin.DateLastModified

		timeStartLogonScript = GetLogonScriptStartTime(strDrivePath)

		timeEndLogonScript = GetLogonScriptEndTime(strDrivePath)

		timeDesktopReady = GetFileDateModifiedByRegex("^USERINIT*", sDesktopReady)

	'	timeDesktopReady = GetFileDateCreatedByRegex("^USERINIT*", sDesktopReady)


Dim strInvFile, ofile
strInvFile = "C:\Program Files\Altiris\eXpress\Inventory\WksBoottime.nsi"
'~ strInvFile = "C:\Temp\WksBoottime.nsi"

set ofile = oFSO.CreateTextFile(strInvFile, True, False)

'--------------------------------------------- Format Table -------------------------------------
AddNSI "<InventoryClasses>"
AddNSI "	<InventoryClass name='AeX Computer Boot Stats18' manufacturer='Altiris' description='Workstation boottime statistics' version='1.0' platform='Win32' mifClass='Altiris|Computer_Network_Desc|1.0'>"
AddNSI "	<xml xmlns:s='uuid:BDC6E3F0-6DA3-11d1-A2A3-00AA00C14882' xmlns:dt='uuid:C2F41010-65B3-11d1-A29F-00AA00C14882' xmlns:rs='urn:schemas-microsoft-com:rowset' xmlns:z='#RowsetSchema'>"
AddNSI "	<s:Schema id='RowsetSchema'>"
AddNSI "		<s:ElementType name='row' content='eltOnly' rs:updatable='False'>"
'~ AddNSI "		<s:ElementType name='row' content='eltOnly' rs:updatable='True'>"

AddNSI "			<s:AttributeType name='c0' rs:name='ADSite' rs:number='1' rs:nullable='true' mifAttrId='1'>"
AddNSI "				<s:datatype dt:type='string' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c1' rs:name='invDate' rs:number='2' rs:nullable='true' mifAttrId='2'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c2' rs:name='UsersEUID' rs:number='3' rs:nullable='true' mifAttrId='3'>"
AddNSI "				<s:datatype dt:type='string' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c3' rs:name='FirstFileModified' rs:number='4' rs:nullable='true' mifAttrId='4'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c4' rs:name='WindowsDefaultBackgroundBlue' rs:number='5' rs:nullable='true' mifAttrId='5'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c5' rs:name='PreparingNetworkConnections' rs:number='6' rs:nullable='true' mifAttrId='6'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c6' rs:name='ApplyingSecuritySettings' rs:number='7' rs:nullable='true' mifAttrId='7'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c7' rs:name='ApplyingComputerSettings' rs:number='8' rs:nullable='true' mifAttrId='8'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c8' rs:name='CrtlAltDel' rs:number='9' rs:nullable='true' mifAttrId='9'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c9' rs:name='UserLogon' rs:number='10' rs:nullable='true' mifAttrId='10'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c10' rs:name='UserLastLogon' rs:number='11' rs:nullable='true' mifAttrId='11'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c11' rs:name='LogonScriptStart' rs:number='12' rs:nullable='true' mifAttrId='12'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c12' rs:name='LogonScriptFinish' rs:number='13' rs:nullable='true' mifAttrId='13'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "			<s:AttributeType name='c13' rs:name='DesktopReady' rs:number='14' rs:nullable='true' mifAttrId='14'>"
AddNSI "				<s:datatype dt:type='dateTime' dt:maxLength='255'/>"
AddNSI "			</s:AttributeType>"

AddNSI "		</s:ElementType>"
AddNSI "	</s:Schema>"
AddNSI "<rs:data>"

'----------------------------------------- Add to Rows --------------------------------------
invDate = TimeConvert(Date() & " " & Time())
timePagefile = TimeConvert(timePagefile)
timeBootstat = TimeConvert(timeBootstat)
timeNetwrk = TimeConvert(timeNetwrk)
timeASS = TimeConvert(timeASS)
timeACS = TimeConvert(timeACS)
timeCtrlAltDel = TimeConvert(timeCtrlAltDel)
timeLogin = TimeConvert(timeLogin)
timeLLogin = TimeConvert(timeLLogin)
timeStartLogonScript = TimeConvert(timeStartLogonScript)
timeEndLogonScript = TimeConvert(timeEndLogonScript)
timeDesktopReady = TimeConvert(timeDesktopReady)

AddNSI "<z:row"
AddNSI "	 c0=" & chr(34) & strADSite & chr(34)
AddNSI "	 c1=" & chr(34) & invDate & chr(34)
AddNSI "	 c2=" & chr(34) & strUsersEUID & chr(34)
AddNSI "	 c3=" & chr(34) & timePagefile & chr(34)
AddNSI "	 c4=" & chr(34) & timeBootstat & chr(34)
AddNSI "	 c5=" & chr(34) & timeNetwrk & chr(34)
AddNSI "	 c6=" & chr(34) & timeASS & chr(34)
AddNSI "	 c7=" & chr(34) & timeACS & chr(34)
AddNSI "	 c8=" & chr(34) & timeCtrlAltDel & chr(34)
AddNSI "	 c9=" & chr(34) & timeLogin & chr(34)
AddNSI "	c10=" & chr(34) & timeLLogin & chr(34)
AddNSI "	c11=" & chr(34) & timeStartLogonScript & chr(34)
AddNSI "	c12=" & chr(34) & timeEndLogonScript & chr(34)
AddNSI "	c13=" & chr(34) & timeDesktopReady & chr(34)
AddNSI "/> "

AddNSI "</rs:data> "
AddNSI "</xml> "
AddNSI "</InventoryClass> "
AddNSI "</InventoryClasses> "

oFile.Close

'Send newly created inventory
Dim strInvSender
strInvSender = strAltirisDir & "\Software Delivery\{01B54EB5-3679-4C73-9E10-E169D5A5EC59}\cache\aexnsinvcollector.exe"
If oFso.FileExists(strInvSender) then
	Dim objWshShell, runStr
	Set objWshShell = WScript.CreateObject("WScript.Shell")
	'~ wscript.echo "send"
	'~ aexnsinvcollector.exe /hidden /nsctransport /v default /useguid
	runStr = chr(34) & strInvSender & chr(34) & " /hidden /nsctransport /v default /useguid"
	objWshShell.Run runStr, 1, false
	Set objWshShell = Nothing
End If

wscript.quit
'---------------------------------------------------------------------- End Main Script --------------------------------------------------------------
Function TimeConvert(t)
	'~ 3/14/2011 9:44:35 PM
	'~ 2011-03-14 21:44:35.000

'~ wscript.echo t
	Dim dtSplit, strDate, strTime
	dtSplit = split(t," ")
	strDate = dtSplit(0)

	strTime = right(t,len(t) - 1 - len(strDate))

	Dim dY, dM, dD, dSplit
	dSplit = split(dtSplit(0),"/")
	dM = AddZero(dSplit(0))
	dD = AddZero(dSplit(1))
	dY = dSplit(2)
	strDate = dY & "-" & dM & "-" & dD
	'~ wscript.echo strDate

	'~ wscript.echo strTime
	Dim tSplit, tH, tM, tS
	tSplit = split(strTime, ":")
	tH = AddZero(tSplit(0))
	tM = AddZero(tSplit(1))
	tS = AddZero(left(tSplit(2),len(tSplit(2)) - 3))
	select case ucase(right(strTime, 2))
		Case "AM"
			'do nothing
		Case "PM"
			tH = tH + 12
	end select
	strTime = tH & ":" & tM & ":" & tS '& ".000"
	'~ wscript.echo strTime
'~ wscript.echo strDate & "T" & strTime
'~ wscript.echo " "
	TimeConvert = strDate & "T" & strTime
end function

Function AddZero(z)
	if len(z) = 1 then
		z = "0" & z
	end if
	AddZero = z
end Function

Sub AddNSI(x)
	oFile.Writeline x
end sub

Function GetLogonScriptStartTime(strDrivePath)
	Dim oShell
	Dim oFSO
	Dim oLogonScript
	Dim sTimeStamp
	Dim sLogonScript
	Dim sContents
	Dim aLines
	Dim i

	Set oShell = CreateObject("Wscript.Shell")
	sLogonScript = strDrivePath & "Program Files\Common Files\DSE\Logs\logonscript.log"

	Set oFSO = CreateObject("Scripting.FileSystemObject")

	On Error Resume Next
	sTimeStamp = ""

	Set oLogonScript = oFSO.OpenTextFile(sLogonScript, 1, False)
	sContents = oLogonScript.ReadAll
	aLines =  Split(sContents, vbCRLF)

	For i = UBound(aLines) to 0 Step -1
		If InStr(1, aLines(i), "BEGIN LOGON SCRIPT", vbTextCompare) <> 0 Then
			sTimeStamp = Mid(aLines(i), 1, InStr(1, aLines(i), "-----", vbTextCompare) - 3)
			Exit For
		End If
	Next

	oLogonScript.Close

	If Err.Number <> 0 Then
		Err.Clear
		GetLogonScriptStartTime = "Logonscript Error (" & Err.Number & "):  " & Err.Description
	End If
	On Error Goto 0

	sTimeStamp = Replace(sTimeStamp, " - ", " ")

	If sTimeStamp <> "" Then
		GetLogonScriptStartTime = sTimeStamp
	Else
		GetLogonScriptStartTime  = "Logonscript Error (unknown):  No timestamp information found."
	End If
	On Error Goto 0
End Function

Function GetLogonScriptEndTime(strDrivePath)
	Dim oShell
	Dim oFSO
	Dim oLogonScript
	Dim sTimeStamp
	Dim sLogonScript
	Dim sContents
	Dim aLines
	Dim i

	Set oShell = CreateObject("Wscript.Shell")
	sLogonScript = strDrivePath & "Program Files\Common Files\DSE\Logs\logonscript.log"

	Set oFSO = CreateObject("Scripting.FileSystemObject")

	On Error Resume Next
	sTimeStamp = ""

	Set oLogonScript = oFSO.OpenTextFile(sLogonScript, 1, False)
	sContents = oLogonScript.ReadAll
	aLines =  Split(sContents, vbCRLF)

	For i = UBound(aLines) to 0 Step -1
		If InStr(1, aLines(i), "Exiting...", vbTextCompare) <> 0 Then
			sTimeStamp = Mid(aLines(i), 1, InStr(1, aLines(i), "Exiting...", vbTextCompare) - 10)
			Exit For
		End If
	Next

	oLogonScript.Close

	If Err.Number <> 0 Then
		Err.Clear
		GetLogonScriptStartTime = "Logonscript Error (" & Err.Number & "):  " & Err.Description
	End If
	On Error Goto 0

	sTimeStamp = Replace(sTimeStamp, " - ", " ")

	If sTimeStamp <> "" Then
		GetLogonScriptEndTime = sTimeStamp
	Else
		GetLogonScriptEndTime = "Logonscript Error (unknown):  No timestamp information found."
	End If
End Function

Function GetFileDateModifiedByRegex(sFileRegEx, sPath)
	Dim oFSO
	Dim oFolder
	Dim cFiles
	Dim oFile
	Dim oRegex
	Dim sFile
	Dim oFoundFile
	Dim sTimeStamp

	Set oFSO = CreateObject("Scripting.FileSystemObject")

	On Error Resume Next
	Set oRegex = new Regexp
	oRegex.Pattern = sFileRegEx
	oRegex.IgnoreCase = True
	sTimeStamp = ""

	Set oFolder = oFSO.GetFolder(sPath)
	Set cFiles = oFolder.Files
	For Each oFile In cFiles
		If oRegex.Test(oFile.Name) Then
			sFile = oFile.Name
			Exit For
		End If
	Next

	Set oFoundFile = oFSO.GetFile(sPath & "\" & sFile)
	sTimeStamp = oFoundFile.DateLastModified

	If Err.Number <> 0 Then
		Err.Clear
		GetLogonScriptStartTime = "Desktop Ready Timestamp Error (" & Err.Number & "):  " & Err.Description
	End If
	On Error Goto 0

	If sTimeStamp <> "" Then
		GetFileDateModifiedByRegex = sTimeStamp
	Else
		GetFileDateModifiedByRegex = "No timestamp information found."
	End If
End Function

Function GetFileDateCreatedByRegex(sFileRegEx, sPath)
	Dim oFSO
	Dim oFolder
	Dim cFiles
	Dim oFile
	Dim oRegex
	Dim sFile
	Dim oFoundFile
	Dim sTimeStamp

	Set oFSO = CreateObject("Scripting.FileSystemObject")

	On Error Resume Next
	Set oRegex = new Regexp
	oRegex.Pattern = sFileRegEx
	oRegex.IgnoreCase = True
	sTimeStamp = ""

	Set oFolder = oFSO.GetFolder(sPath)
	Set cFiles = oFolder.Files
	For Each oFile In cFiles
		If oRegex.Test(oFile.Name) Then
			sFile = oFile.Name
			Exit For
		End If
	Next

	Set oFoundFile = oFSO.GetFile(sPath & "\" & sFile)
	sTimeStamp = oFoundFile.DateCreated

	If Err.Number <> 0 Then
		Err.Clear
		GetFileDateCreatedByRegex = "Desktop Ready Timestamp Error (" & Err.Number & "):  " & Err.Description
	End If
	On Error Goto 0

	If sTimeStamp <> "" Then
		GetFileDateCreatedByRegex = sTimeStamp
	Else
		GetFileDateCreatedByRegex = "No timestamp information found."
	End If
End Function

'---------------------------------------------------------------------------------------'
' This function retrieves the device's current user and returns the resultant  '
' string.                                                                                                  '
'-------------------------------------------------------------------------------------- '
Function GetCurrentUser(strDrivePath)
	Dim oFSO                                            ' file system object
	Dim oDocsSettings          ' documents and settings folder object
	Dim cUserFolders                            ' collection of user folders
	Dim oUserFolder                              ' user folder object
	Dim oNTDAT                      ' ntdat.dat file object
	Dim dateModified                           ' date last modified
	Dim sUser                                           ' user

	dateModified = ""
	strPath = strDrivePath & "Documents and Settings"
	' Retrieve current user
	Set oFSO = CreateObject("Scripting.FileSystemObject")
	Set oDocsSettings = oFSO.GetFolder(strpath)
	Set cUserFolders = oDocsSettings.SubFolders
	For Each oUserFolder in cUserFolders
					On Error Resume Next
	Set oNTDAT = oFSO.GetFile(oUserFolder.Path & "\NTUSER.DAT")
	If StrComp(dateModified, "", vbTextCompare) = 0 Then
									dateModified = oNTDAT.DateLastModified
									sUser = oUserFolder.Name
					Else If oNTDAT.DateLastModified >= dateModified Then
									dateModified = oNTDAT.DateLastModified
									sUser = oUserFolder.Name
					End If
					End If

					' Clean up
					Set oNTDAT = Nothing
				   On Error Goto 0

   Next

	' Clean up
	Set oFSO = Nothing
	Set oDocsSettings = Nothing
	Set cUserFolders = Nothing
	Set oUserFolder = Nothing

	' Return the device serial number
	GetCurrentUser = sUser
End Function